import { IColorRamp } from '@antv/l7-utils';
import BaseLayer from '../core/BaseLayer';
import { RasterModelType } from './models/index';
interface IRasterLayerStyleOptions {
    opacity: number;
    domain: [number, number];
    noDataValue: number;
    clampLow: boolean;
    clampHigh: boolean;
    rampColors: IColorRamp;
}
export default class RaterLayer extends BaseLayer<IRasterLayerStyleOptions> {
    type: string;
    buildModels(): void;
    protected getConfigSchema(): {
        properties: {
            opacity: {
                type: string;
                minimum: number;
                maximum: number;
            };
        };
    };
    protected getDefaultConfig(): {} | {};
    protected getModelType(): RasterModelType;
}
export {};
